
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Overtime_logsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const overtime_logs = await db.overtime_logs.create(
            {
                id: data.id || undefined,
        
        work_date: data.work_date
        ||
        null
            ,
            
        hours: data.hours
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
        approval_status: data.approval_status
        ||
        null
            ,
            
        approved_at: data.approved_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await overtime_logs.setEmployee( data.employee || null, {
            transaction,
        });
        
        await overtime_logs.setOutlet( data.outlet || null, {
            transaction,
        });
        
        await overtime_logs.setApproved_by_user( data.approved_by_user || null, {
            transaction,
        });
        
        await overtime_logs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return overtime_logs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const overtime_logsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                work_date: item.work_date
            ||
            null
            ,
            
                hours: item.hours
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
                approval_status: item.approval_status
            ||
            null
            ,
            
                approved_at: item.approved_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const overtime_logs = await db.overtime_logs.bulkCreate(overtime_logsData, { transaction });

        // For each item created, replace relation files
        

        return overtime_logs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const overtime_logs = await db.overtime_logs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.work_date !== undefined) updatePayload.work_date = data.work_date;
        
        
        if (data.hours !== undefined) updatePayload.hours = data.hours;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        if (data.approval_status !== undefined) updatePayload.approval_status = data.approval_status;
        
        
        if (data.approved_at !== undefined) updatePayload.approved_at = data.approved_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await overtime_logs.update(updatePayload, {transaction});

        
        
        if (data.employee !== undefined) {
            await overtime_logs.setEmployee(
              
              data.employee,
              
              { transaction }
            );
        }
        
        if (data.outlet !== undefined) {
            await overtime_logs.setOutlet(
              
              data.outlet,
              
              { transaction }
            );
        }
        
        if (data.approved_by_user !== undefined) {
            await overtime_logs.setApproved_by_user(
              
              data.approved_by_user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await overtime_logs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return overtime_logs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const overtime_logs = await db.overtime_logs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of overtime_logs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of overtime_logs) {
                await record.destroy({transaction});
            }
        });


        return overtime_logs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const overtime_logs = await db.overtime_logs.findByPk(id, options);

        await overtime_logs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await overtime_logs.destroy({
            transaction
        });

        return overtime_logs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const overtime_logs = await db.overtime_logs.findOne(
            { where },
            { transaction },
        );

        if (!overtime_logs) {
            return overtime_logs;
        }

        const output = overtime_logs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.employee = await overtime_logs.getEmployee({
            transaction
        });
        
        
        output.outlet = await overtime_logs.getOutlet({
            transaction
        });
        
        
        output.approved_by_user = await overtime_logs.getApproved_by_user({
            transaction
        });
        
        
        output.organizations = await overtime_logs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.employees,
        as: 'employee',
        
        where: filter.employee ? {
          [Op.or]: [
            { id: { [Op.in]: filter.employee.split('|').map(term => Utils.uuid(term)) } },
            {
              full_name: {
                [Op.or]: filter.employee.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.outlets,
        as: 'outlet',
        
        where: filter.outlet ? {
          [Op.or]: [
            { id: { [Op.in]: filter.outlet.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.outlet.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'approved_by_user',
        
        where: filter.approved_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approved_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.approved_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'overtime_logs',
                        'reason',
                        filter.reason,
                    ),
                };
            }
            

            
            

            
            if (filter.work_dateRange) {
                const [start, end] = filter.work_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    work_date: {
                    ...where.work_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    work_date: {
                    ...where.work_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.hoursRange) {
                const [start, end] = filter.hoursRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    hours: {
                    ...where.hours,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    hours: {
                    ...where.hours,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.approved_atRange) {
                const [start, end] = filter.approved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    approved_at: {
                    ...where.approved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.approval_status) {
                where = {
                    ...where,
                approval_status: filter.approval_status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.overtime_logs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'overtime_logs',
                        'reason',
                        query,
                    ),
                ],
            };
        }

        const records = await db.overtime_logs.findAll({
            attributes: [ 'id', 'reason' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reason', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reason,
        }));
    }

    
};

